package ru.dbotthepony.kommons.test

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import ru.dbotthepony.kommons.io.BTreeDB6
import ru.dbotthepony.kommons.io.ByteKey
import java.io.File
import java.util.concurrent.Executor
import kotlin.test.assertEquals

object BTreeDB6Tests {
	@Test
	@DisplayName("BTreeDB6 Tests")
	fun test() {
		val file = File("dbtest.bdb")
		if (file.exists()) file.delete()
		val create = BTreeDB6.create(file, 4096, sync = false)

		for (i in 0 .. 8000) {
			val s = "This is key $i"
			val k = ByteKey("This is key $i")
			create.write(k, s.toByteArray())
			assertEquals(s, String(create.read(k).get()))
		}

		for (i in 0 .. 8000) {
			val s = "This is key $i"
			val k = ByteKey("This is key $i")
			assertEquals(s, String(create.read(k).get()))
		}

		for (i in 0 .. 8000) {
			val s = "This is key $i"
			val k = ByteKey("This is key $i")
			create.write(k, s.toByteArray())
			assertEquals(s, String(create.read(k).get()))
		}

		create.close()

		val create2 = BTreeDB6(file)

		for (i in 0 .. 8000) {
			val s = "This is key $i"
			val k = ByteKey("This is key $i")
			assertEquals(s, String(create2.read(k).get()))
		}

		create2.checkFreeBitmap()
		create2.close()
	}
}
